import { GridModel } from '../grid/grid.model';
import { SceneModel } from '../scene/scene.model';
import { ViewModel } from '../view/view.model';
import { DataModel } from '../data/data.model';
import { HeadModel } from '../head/head.model';
import { BodyModel } from '../body/body.model';
import { LayoutModel } from '../layout/layout.model';
import { NavigationModel } from '../navigation/navigation.model';
import { FocusModel } from '../focus/focus.model';
import { ColumnListModel } from '../column-list/column.list.model';
import { RowModel } from '../row/row.model';
import { SelectionModel } from '../selection/selection.model';
import { FootModel } from '../foot/foot.model';
import { SortModel } from '../sort/sort.model';
import { GroupModel } from '../group/group.model';
import { PivotModel } from '../pivot/pivot.model';
import { PluginModel } from '../plugin/plugin.model';
import { EditModel } from '../edit/edit.model';
import { ToolbarModel } from '../toolbar/toolbar.model';
import { LayerModel } from '../layer/layer.model';
import { PaginationModel } from '../pagination/pagination.model';
import { ProgressModel } from '../progress/progress.model';
import { HighlightModel } from '../highlight/highlight.model';
import { VisibilityModel } from '../visibility/visibility.model';
import { FilterModel } from '../filter/filter.model';
import { DragModel } from '../drag/drag.model';
import { StyleModel } from '../style/style.model';
import { ScrollModel } from '../scroll/scroll.model';
import { ExportModel } from '../export/export.model';
import { ActionModel } from '../action/action.model';
import { FetchModel } from '../fetch/fetch.model';
import { ValidationModel } from '../validation/validation.model';
import { Event } from './event';
import { PersistenceModel } from '../persistence/persistence.model';
import { PipeModel } from '../pipe/pipe.model';

export declare class Model {
	constructor();

	gridChanged: Event;
	sceneChanged: Event;
	pipeChanged: Event;
	editChanged: Event;
	viewChanged: Event;
	dataChanged: Event;
	headChanged: Event;
	bodyChanged: Event;
	layoutChanged: Event;
	navigationChanged: Event;
	focusChanged: Event;
	rowChanged: Event;
	selectionChanged: Event;
	columnChanged: Event;
	footChanged: Event;
	sortChanged: Event;
	groupChanged: Event;
	pivotChanged: Event;
	pluginChanged: Event;
	toolbarChanged: Event;
	layerChanged: Event;
	paginationChanged: Event;
	progressChanged: Event;
	highlightChanged: Event;
	visibilityChanged: Event;
	filterChanged: Event;
	dragChanged: Event;
	styleChanged: Event;
	scrollChanged: Event;
	exportChanged: Event;
	actionChanged: Event;
	fetchChanged: Event;
	persistenceChanged: Event;
	validationChanged: Event;
	queryBuilderChanged: Event;

	static register(name: string, model: { new(): {} }): typeof Model;

	grid(value: object, tag?: object): Model;
	grid(): GridModel;
	pipe(value: object, tag?: object): Model;
	pipe(): PipeModel;
	scene(value: object, tag?: object): Model;
	scene(): SceneModel;
	edit(value: object, tag?: object): Model;
	edit(): EditModel;
	view(value: object, tag?: object): Model;
	view(): ViewModel;
	data(value: object, tag?: object): Model;
	data(): DataModel;
	head(value: object, tag?: object): Model;
	head(): HeadModel;
	body(value: object, tag?: object): Model;
	body(): BodyModel;
	layout(value: object, tag?: object): Model;
	layout(): LayoutModel;
	navigation(value: object, tag?: object): Model;
	navigation(): NavigationModel;
	focus(value: object, tag?: object): Model;
	focus(): FocusModel;
	columnList(value: object, tag?: object): Model;
	columnList(): ColumnListModel;
	row(value: object, tag?: object): Model;
	row(): RowModel;
	selection(value: object, tag?: object): Model;
	selection(): SelectionModel;
	foot(value: object, tag?: object): Model;
	foot(): FootModel;
	sort(value: object, tag?: object): Model;
	sort(): SortModel;
	group(value: object, tag?: object): Model;
	grop(): GroupModel;
	pivot(value: object, tag?: object): Model;
	pivot(): PivotModel;
	plugin(value: object, tag?: object): Model;
	plugin(): PluginModel;
	toolbar(value: object, tag?: object): Model;
	toolbar(): ToolbarModel;
	layer(value: object, tag?: object): Model;
	layer(): LayerModel;
	pagination(value: object, tag?: object): Model;
	pagination(): PaginationModel;
	progress(value: object, tag?: object): Model;
	progres(): ProgressModel;
	highlight(value: object, tag?: object): Model;
	highlight(): HighlightModel;
	visibility(value: object, tag?: object): Model;
	visibility(): VisibilityModel;
	filter(value: object, tag?: object): Model;
	filter(): FilterModel;
	drag(value?: object, tag?: object): DragModel;
	style(value: object, tag?: object): Model;
	style(): StyleModel;
	scroll(value: object, tag?: object): Model;
	scroll(): ScrollModel;
	export(value: object, tag?: object): Model;
	export(): ExportModel;
	action(value: object, tag?: object): Model;
	action(): ActionModel;
	fetch(value: object, tag?: object): Model;
	fetch(): FetchModel;
	persistence(value: object, tag?: object): Model;
	persistence(): PersistenceModel;
	validation(value: object, tag?: object): Model;
	validation(): ValidationModel;
	queryBuilder(value: object, tag?: object): Model;
	queryBuilder(): any;
	dataManipulation(value: object, tag?: object): Model;
	dataManipulation(): any;
	rest(value: object, tag?: object): Model;
	rest(): any;
}
