## description
Current navigation based on DHTML Style Guide Working Group (DSGWG) recommendations for keyboard shortcuts and keyboard navigation
http://access.aol.com/dhtml-style-guide-working-group

## key map
<table class="attributes">
<thead>
	<tr>
		<th>Key</th>
		<th>Description</th>
	</tr>
</thead>
<tbody>
	<tr>
	  <td>Tab</td>
	  <td>
	  <ul>
	  	<li>
	   	The initial <code>Tab</code> enters the grid with focus on the first cell of the first row
	   </li>
	  	<li>
	      A second <code>Tab</code> moves out of the grid to the next tab stop on the page
	   </li>
	  	<li>
   	   Once focus is established in the grid, a <code>Tab</code> into or a <code>Shift+Tab</code> into the grid will return to the cell which last had focus
	   </li>
	</td>
	</tr>
	<tr>
	  <td>Left|Right Arrow</td>
	  <td>Move focus to the adjacent column’s cell. There is no wrap at the end or beginning of columns</td>
	</tr>
	<tr>
	  <td>Up|Down Arrow</td>
	  <td>Move focus to the adjacent row’s cell. There is no wrap at the first or last row</td>
	</tr>
	<tr>
	  <td>Home</td>
	  <td>Moves focus to the first cell of the current row</td>
	</tr>
	<tr>
	  <td>End</td>
	  <td>Moves focus to the last cell of the current row</td>
	</tr>
	<tr>
	  <td>Page Up</td>
	  <td>Moves focus to the first cell in the current column</td>
	</tr>
	<tr>
	  <td>Page Down</td>
	  <td>Moves focus to the last cell in the current column</td>
	</tr>
	<tr>
	  <td>Enter|F2</td>
	  <td>While focus is on a cell containing an actionable item will enter Action Mode</td>
	</tr>
	<tr>
	  <td>Action Mode + Tab</td>
	  <td>Pressing the <code>Tab</code> key while in actionable mode moves focus to the next actionable item within the grid, wrapping when the last actionable item in the grid is reached.</td>
	</tr>
	<tr>
	  <td>Action Mode + Shift+Tab</td>
	  <td>Does the same as <code>Tab</code> but in reverse order</td>
	</tr>
	<tr>
	  <td>Action Mode + Esc</td>
	  <td>Exits Action Mode</td>
	</tr>
</tbody>
</table>

## selection
<table class="attributes">
<thead>
	<tr>
		<th>Key</th>
		<th>Description</th>
	</tr>
</thead>
<tbody>
	<tr>
		<td>Shift+Space</td>
		<td>Toggle active row</td>
	</tr>
	<tr>
		<td>Control+Space</td>
		<td>Toggle active column</td>
	</tr>
	<tr>
		<td>Control+A</td>
		<td>Select all units (rows/columns/cells)</td>
	</tr>
	<tr>
		<td>Shift+Arrows</td>
		<td>Extend selection</td>
	</tr>
</tbody>
</table>